diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/filter/DateAttributeFilter.java b/sources/src/cz/zcu/kiv/offscreen/graph/filter/DateAttributeFilter.java
new file mode 100644
index 0000000..5296555
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/filter/DateAttributeFilter.java
@@ -0,0 +1,57 @@
+package cz.zcu.kiv.offscreen.graph.filter;
+
+import java.util.Date;
+
+public class DateAttributeFilter implements ITypeAttributeFilter {
+    private Date min;
+    private Date max;
+    private boolean minInclusive;
+    private boolean maxInclusive;
+    private GraphFilter.DateMatchType matchType;
+
+    public DateAttributeFilter(Date min, Date max, boolean minInclusive, boolean maxInclusive, GraphFilter.DateMatchType matchType) {
+        this.min = min;
+        this.max = max;
+        this.minInclusive = minInclusive;
+        this.maxInclusive = maxInclusive;
+        this.matchType = matchType;
+    }
+
+    @Override
+    public boolean filter(Object value) {
+        Date date = (Date) value;
+        boolean result = false;
+
+        int cmpMin = -1;
+        int cmpMax = 1;
+
+        if (minInclusive) cmpMin = 0;
+        if (maxInclusive) cmpMax = 0;
+
+        if (min.compareTo(date) <= cmpMin && max.compareTo(date) >= cmpMax) {
+            result = true;
+        }
+
+        return (matchType == GraphFilter.DateMatchType.MATCHING) == result;
+    }
+
+    public Date getMin() {
+        return min;
+    }
+
+    public Date getMax() {
+        return max;
+    }
+
+    public boolean isMinInclusive() {
+        return minInclusive;
+    }
+
+    public boolean isMaxInclusive() {
+        return maxInclusive;
+    }
+
+    public GraphFilter.DateMatchType getMatchType() {
+        return matchType;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/filter/EdgeArchetypeFilter.java b/sources/src/cz/zcu/kiv/offscreen/graph/filter/EdgeArchetypeFilter.java
new file mode 100644
index 0000000..cb5bcdf
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/filter/EdgeArchetypeFilter.java
@@ -0,0 +1,15 @@
+package cz.zcu.kiv.offscreen.graph.filter;
+
+import cz.zcu.kiv.offscreen.graph.EdgeArchetypeInfo;
+
+import java.util.List;
+
+public class EdgeArchetypeFilter {
+    public List<EdgeArchetypeInfo> archetypeIndeces;
+    public GraphFilter.ArchetypeMatchType matchType;
+
+    public EdgeArchetypeFilter(List<EdgeArchetypeInfo> archetypeIndeces, GraphFilter.ArchetypeMatchType matchType) {
+        this.archetypeIndeces = archetypeIndeces;
+        this.matchType = matchType;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/filter/EnumAttributeFilter.java b/sources/src/cz/zcu/kiv/offscreen/graph/filter/EnumAttributeFilter.java
new file mode 100644
index 0000000..1233ef7
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/filter/EnumAttributeFilter.java
@@ -0,0 +1,61 @@
+package cz.zcu.kiv.offscreen.graph.filter;
+
+import java.util.List;
+
+public class EnumAttributeFilter implements ITypeAttributeFilter {
+    private List<Integer> valueIndices;
+    private GraphFilter.EnumMatchType matchType;
+
+    public EnumAttributeFilter(List<Integer> valueIndices, GraphFilter.EnumMatchType matchType) {
+        this.valueIndices = valueIndices;
+        this.matchType = matchType;
+    }
+
+    @Override
+    public boolean filter(Object value) {
+        boolean result = true;
+        List<Integer> val = (List<Integer>) value;
+
+        switch (matchType) {
+            case ANY:
+                for (int e : val) {
+                    if (valueIndices.contains(e)) {
+                        return true;
+                    }
+                }
+                result = false;
+                break;
+            case NONE:
+                for (int e : val) {
+                    if (valueIndices.contains(e)) {
+                        return false;
+                    }
+                }
+                result = true;
+                break;
+            case EXACT_MATCH:
+                for (int e : val) {
+                    if (!valueIndices.contains(e)) {
+                        return false;
+                    }
+                }
+                for (int e : valueIndices) {
+                    if (!val.contains(e)) {
+                        return false;
+                    }
+                }
+                result = true;
+                break;
+        }
+
+        return result;
+    }
+
+    public List<Integer> getValueIndices() {
+        return valueIndices;
+    }
+
+    public GraphFilter.EnumMatchType getMatchType() {
+        return matchType;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/filter/GraphFilter.java b/sources/src/cz/zcu/kiv/offscreen/graph/filter/GraphFilter.java
new file mode 100644
index 0000000..ce36932
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/filter/GraphFilter.java
@@ -0,0 +1,226 @@
+package cz.zcu.kiv.offscreen.graph.filter;
+
+import cz.zcu.kiv.offscreen.graph.EdgeArchetypeInfo;
+
+import java.math.BigDecimal;
+import java.util.Date;
+import java.util.HashMap;
+import java.util.List;
+
+public class GraphFilter {
+    public enum ArchetypeMatchType {
+        /**
+         * accepts all the archetypes in the list
+         */
+        MATCHING,
+
+        /**
+         * accepts all the available archetypes except those in the list
+         */
+        NON_MATCHING
+    }
+
+    public enum NumberMatchType {
+        /**
+         * accepts all numbers that belong to the interval
+         */
+        MATCHING,
+
+        /**
+         * accepts all numbers that are outside the interval
+         */
+        NON_MATCHING
+    }
+
+    public enum EnumMatchType {
+        /**
+         * accepts when the attribute has at least one of the values in the list
+         */
+        ANY,
+
+        /**
+         * accepts when the attribute has none of the values in the list
+         */
+        NONE,
+
+        /**
+         * accepts when the attribute has the exact values as the values in the list and none other
+         */
+        EXACT_MATCH
+    }
+
+    public enum DateMatchType {
+        /**
+         * accepts all dates that belong to the interval
+         */
+        MATCHING,
+
+        /**
+         * accepts all dates that are outside the interval
+         */
+        NON_MATCHING
+    }
+
+    public enum StringMatchType {
+        /**
+         * accepts strings that have the exact filter value
+         */
+        EXACT_MATCH,
+
+        /**
+         * accepts strings that have any value different from the filter value
+         */
+        EXACT_MISMATCH,
+
+        /**
+         * accepts strings that contain the filter value as a substring
+         */
+        CONTAINING,
+
+        /**
+         * accepts strings that do not contain the filter value as s substring
+         */
+        NON_CONTAINING,
+
+        /**
+         * accepts strings that are accepted by the regular expression defined by the filter value
+         */
+        REGULAR_EXPRESSION
+    }
+
+    private VertexArchetypeFilter vertexArchetypeFilter;
+    private EdgeArchetypeFilter edgeArchetypeFilter;
+
+    /**
+     * key is the vertex archetype index, value is the filter object
+     */
+    private HashMap<Integer, AttributeFilter> vertexAttributeFilters = new HashMap<>();
+
+    /**
+     * key is the edge archetype index, value is the filter object
+     */
+    private HashMap<Integer, AttributeFilter> edgeAttributeFilters = new HashMap<Integer, AttributeFilter>();
+
+    public AttributeFilter getVertexAttributeFilter(int archetypeIndex) {
+        return vertexAttributeFilters.get(archetypeIndex);
+    }
+
+    public AttributeFilter getEdgeAttributeFilter(int archetypeIndex) {
+        return edgeAttributeFilters.get(archetypeIndex);
+    }
+
+    public VertexArchetypeFilter getVertexArchetypeFilter() {
+        return vertexArchetypeFilter;
+    }
+
+    public EdgeArchetypeFilter getEdgeArchetypeFilter() {
+        return edgeArchetypeFilter;
+    }
+
+    public void setVertexArchetypeFilter(List<Integer> archetypeIndices, ArchetypeMatchType matchType) {
+        vertexArchetypeFilter = new VertexArchetypeFilter(archetypeIndices, matchType);
+    }
+
+    public void setEdgeArchetypeFilter(List<EdgeArchetypeInfo> archetypeIndices, ArchetypeMatchType matchType) {
+        edgeArchetypeFilter = new EdgeArchetypeFilter(archetypeIndices, matchType);
+    }
+
+    public void setVertexNumberAttributeFilter(int archetypeIndex, int attributeTypeIndex, BigDecimal min, BigDecimal max, boolean minInclusive, boolean maxInclusive, NumberMatchType matchType) {
+        AttributeFilter filter;
+        if (vertexAttributeFilters.containsKey(archetypeIndex)) {
+            filter = vertexAttributeFilters.get(archetypeIndex);
+        } else {
+            filter = new AttributeFilter();
+            vertexAttributeFilters.put(archetypeIndex, filter);
+        }
+        filter.addNumberFilter(attributeTypeIndex, new NumberAttributeFilter(min, max, minInclusive, maxInclusive, matchType));
+    }
+
+    public void setEdgeNumberAttributeFilter(int archetypeIndex, int attributeTypeIndex, BigDecimal min, BigDecimal max, boolean minInclusive, boolean maxInclusive, NumberMatchType matchType) {
+        AttributeFilter filter;
+        if (edgeAttributeFilters.containsKey(archetypeIndex)) {
+            filter = edgeAttributeFilters.get(archetypeIndex);
+        } else {
+            filter = new AttributeFilter();
+            edgeAttributeFilters.put(archetypeIndex, filter);
+        }
+        filter.addNumberFilter(attributeTypeIndex, new NumberAttributeFilter(min, max, minInclusive, maxInclusive, matchType));
+    }
+
+    public void setVertexEnumAttributeFilter(int archetypeIndex, int attributeTypeIndex, List<Integer> valueIndices, EnumMatchType matchType) {
+        AttributeFilter filter;
+        if (vertexAttributeFilters.containsKey(archetypeIndex)) {
+            filter = vertexAttributeFilters.get(archetypeIndex);
+        } else {
+            filter = new AttributeFilter();
+            vertexAttributeFilters.put(archetypeIndex, filter);
+        }
+        filter.addEnumFilter(attributeTypeIndex, new EnumAttributeFilter(valueIndices, matchType));
+    }
+
+    public void setEdgeEnumAttributeFilter(int archetypeIndex, int attributeTypeIndex, List<Integer> valueIndices, EnumMatchType matchType) {
+        AttributeFilter filter;
+        if (edgeAttributeFilters.containsKey(archetypeIndex)) {
+            filter = edgeAttributeFilters.get(archetypeIndex);
+        } else {
+            filter = new AttributeFilter();
+            edgeAttributeFilters.put(archetypeIndex, filter);
+        }
+        filter.addEnumFilter(attributeTypeIndex, new EnumAttributeFilter(valueIndices, matchType));
+    }
+
+    public void setVertexDateAttributeFilter(int archetypeIndex, int attributeTypeIndex, Date min, Date max, boolean minInclusive, boolean maxInclusive, DateMatchType matchType) {
+        AttributeFilter filter;
+        if (vertexAttributeFilters.containsKey(archetypeIndex)) {
+            filter = vertexAttributeFilters.get(archetypeIndex);
+        } else {
+            filter = new AttributeFilter();
+            vertexAttributeFilters.put(archetypeIndex, filter);
+        }
+        filter.addDateFilter(attributeTypeIndex, new DateAttributeFilter(min, max, minInclusive, maxInclusive, matchType));
+    }
+
+    public void setEdgeDateAttributeFilter(int archetypeIndex, int attributeTypeIndex, Date min, Date max, boolean minInclusive, boolean maxInclusive, DateMatchType matchType) {
+        AttributeFilter filter;
+        if (edgeAttributeFilters.containsKey(archetypeIndex)) {
+            filter = edgeAttributeFilters.get(archetypeIndex);
+        } else {
+            filter = new AttributeFilter();
+            edgeAttributeFilters.put(archetypeIndex, filter);
+        }
+        filter.addDateFilter(attributeTypeIndex, new DateAttributeFilter(min, max, minInclusive, maxInclusive, matchType));
+    }
+
+    public void setVertexStringAttributeFilter(int archetypeIndex, int attributeTypeIndex, String filterValue, StringMatchType matchType) {
+        AttributeFilter filter;
+        if (vertexAttributeFilters.containsKey(archetypeIndex)) {
+            filter = vertexAttributeFilters.get(archetypeIndex);
+        } else {
+            filter = new AttributeFilter();
+            vertexAttributeFilters.put(archetypeIndex, filter);
+        }
+        filter.addStringFilter(attributeTypeIndex, new StringAttributeFilter(filterValue, matchType));
+    }
+
+    public void setEdgeStringAttributeFilter(int archetypeIndex, int attributeTypeIndex, String filterValue, StringMatchType matchType) {
+        AttributeFilter filter;
+        if (edgeAttributeFilters.containsKey(archetypeIndex)) {
+            filter = edgeAttributeFilters.get(archetypeIndex);
+        } else {
+            filter = new AttributeFilter();
+            edgeAttributeFilters.put(archetypeIndex, filter);
+        }
+        filter.addStringFilter(attributeTypeIndex, new StringAttributeFilter(filterValue, matchType));
+    }
+
+    /*
+    advised filtering process:
+    first filter the archetypes using queries in the hash maps in GraphManager
+    then iterate through all vertices/edges that are left after the first step and for each vertex/edge do the following:
+     - use getVertex/EdgeAttributeFilter in GraphFilter to get the filer setting for the given archetype, this returns AttributeFilter
+     - iterate through all attributes of the vertex/edge and do the following:
+        - get the attribute data type and index
+        - use getString/Number/Enum/DateFilter in AttributeFilter to get the filter for the given attribute
+        - decide whether the attribute's value passes the filter and whether to keep the give vertex/edge or not
+     */
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/filter/ITypeAttributeFilter.java b/sources/src/cz/zcu/kiv/offscreen/graph/filter/ITypeAttributeFilter.java
new file mode 100644
index 0000000..e28194f
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/filter/ITypeAttributeFilter.java
@@ -0,0 +1,5 @@
+package cz.zcu.kiv.offscreen.graph.filter;
+
+public interface ITypeAttributeFilter {
+    boolean filter(Object value);
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/filter/NumberAttributeFilter.java b/sources/src/cz/zcu/kiv/offscreen/graph/filter/NumberAttributeFilter.java
new file mode 100644
index 0000000..3b67d2c
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/filter/NumberAttributeFilter.java
@@ -0,0 +1,57 @@
+package cz.zcu.kiv.offscreen.graph.filter;
+
+import java.math.BigDecimal;
+
+public class NumberAttributeFilter implements ITypeAttributeFilter {
+    private BigDecimal min;
+    private BigDecimal max;
+    private boolean minInclusive;
+    private boolean maxInclusive;
+    private GraphFilter.NumberMatchType matchType;
+
+    public NumberAttributeFilter(BigDecimal min, BigDecimal max, boolean minInclusive, boolean maxInclusive, GraphFilter.NumberMatchType matchType) {
+        this.min = min;
+        this.max = max;
+        this.minInclusive = minInclusive;
+        this.maxInclusive = maxInclusive;
+        this.matchType = matchType;
+    }
+
+    @Override
+    public boolean filter(Object value) {
+        BigDecimal val = (BigDecimal) value;
+        boolean result = false;
+
+        int cmpMin = -1;
+        int cmpMax = 1;
+
+        if (minInclusive) cmpMin = 0;
+        if (maxInclusive) cmpMax = 0;
+
+        if (min.compareTo(val) <= cmpMin && max.compareTo(val) >= cmpMax) {
+            result = true;
+        }
+
+        return (matchType == GraphFilter.NumberMatchType.MATCHING) == result;
+    }
+
+    public BigDecimal getMin() {
+        return min;
+    }
+
+    public BigDecimal getMax() {
+        return max;
+    }
+
+    public boolean isMinInclusive() {
+        return minInclusive;
+    }
+
+    public boolean isMaxInclusive() {
+        return maxInclusive;
+    }
+
+    public GraphFilter.NumberMatchType getMatchType() {
+        return matchType;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/filter/StringAttributeFilter.java b/sources/src/cz/zcu/kiv/offscreen/graph/filter/StringAttributeFilter.java
new file mode 100644
index 0000000..1280fd7
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/filter/StringAttributeFilter.java
@@ -0,0 +1,50 @@
+package cz.zcu.kiv.offscreen.graph.filter;
+
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
+public class StringAttributeFilter implements ITypeAttributeFilter {
+    private String filterValue;
+    private GraphFilter.StringMatchType matchType;
+
+    public StringAttributeFilter(String filterValue, GraphFilter.StringMatchType matchType) {
+        this.filterValue = filterValue;
+        this.matchType = matchType;
+    }
+
+    @Override
+    public boolean filter(Object value) {
+        String val = (String) value;
+        boolean result = false;
+
+        switch (matchType) {
+            case EXACT_MATCH:
+                if (val.equals(filterValue)) result = true;
+                break;
+            case EXACT_MISMATCH:
+                if (!val.equals(filterValue)) result = true;
+                break;
+            case CONTAINING:
+                if (val.contains(filterValue)) result = true;
+                break;
+            case NON_CONTAINING:
+                if (!val.contains(filterValue)) result = true;
+                break;
+            case REGULAR_EXPRESSION:
+                Pattern pattern = Pattern.compile(filterValue);
+                Matcher matcher = pattern.matcher(val);
+                if (matcher.find()) result = true;
+                break;
+        }
+
+        return result;
+    }
+
+    public String getFilterValue() {
+        return filterValue;
+    }
+
+    public GraphFilter.StringMatchType getMatchType() {
+        return matchType;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/filter/VertexArchetypeFilter.java b/sources/src/cz/zcu/kiv/offscreen/graph/filter/VertexArchetypeFilter.java
new file mode 100644
index 0000000..21f19ca
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/filter/VertexArchetypeFilter.java
@@ -0,0 +1,13 @@
+package cz.zcu.kiv.offscreen.graph.filter;
+
+import java.util.List;
+
+public class VertexArchetypeFilter {
+    public List<Integer> archetypeIndeces;
+    public GraphFilter.ArchetypeMatchType matchType;
+
+    public VertexArchetypeFilter(List<Integer> archetypeIndeces, GraphFilter.ArchetypeMatchType matchType) {
+        this.archetypeIndeces = archetypeIndeces;
+        this.matchType = matchType;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/loader/GraphJSONDataLoader.java b/sources/src/cz/zcu/kiv/offscreen/graph/loader/GraphJSONDataLoader.java
new file mode 100644
index 0000000..ae7b5d9
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/loader/GraphJSONDataLoader.java
@@ -0,0 +1,223 @@
+package cz.zcu.kiv.offscreen.graph.loader;
+
+import cz.zcu.kiv.offscreen.graph.Attribute;
+import cz.zcu.kiv.offscreen.graph.EdgeArchetypeInfo;
+import cz.zcu.kiv.offscreen.graph.GraphManager;
+import net.sf.json.JSONArray;
+import net.sf.json.JSONObject;
+import org.apache.commons.io.FileUtils;
+
+import java.io.File;
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.text.ParsePosition;
+import java.text.SimpleDateFormat;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+/**
+ * Class loads json file with graph data.
+ * @author Stepan Baratta
+ */
+public class GraphJSONDataLoader {
+
+    private File file;
+    private String loadedJSON;
+
+    private GraphManager graphManager;
+
+    /**
+     * stores archetypes of vertices, key is the vertex id, value is the index of its archetype
+     */
+    private HashMap<Integer, Integer> vertexArchetypes = new HashMap<Integer, Integer>();
+
+    static final String DATETIME_FORMAT = "yyyy-MM-dd HH:mm:ss";
+
+    public GraphJSONDataLoader(File file) {
+        this.file = file;
+    }
+
+    private void loadJSON() throws IOException {
+        loadedJSON = FileUtils.readFileToString(file, "UTF-8");
+    }
+
+    public GraphManager LoadData() throws IOException {
+        this.graphManager = new GraphManager();
+
+        loadJSON();
+        JSONObject json = JSONObject.fromObject(loadedJSON);
+
+        JSONArray attributeTypes = getLoadedAttributeTypes(json);
+
+        loadVertexArchetypes(json);
+
+        loadEdgeArchetypes(json);
+
+        loadVertices(attributeTypes, json);
+
+        loadEdges(attributeTypes, json);
+
+        return graphManager;
+    }
+
+    /**
+     * Returns the json array with the loaded attribute types.
+     * Adds the attributes to the list of all attribute types.
+     * @param json
+     * @return - Json array with the attribute types.
+     */
+    private JSONArray getLoadedAttributeTypes(JSONObject json) {
+        JSONArray attributeTypes = json.getJSONArray("attributeTypes");
+        for (int i = 0; i < attributeTypes.size(); i++) {
+            JSONObject attributeType = attributeTypes.getJSONObject(i);
+            String dataTypeString = attributeType.getString("dataType");
+            GraphManager.AttributeDataType dataType;
+            switch (dataTypeString) {
+                case "number": dataType = GraphManager.AttributeDataType.NUMBER; break;
+                case "date": dataType = GraphManager.AttributeDataType.DATE; break;
+                case "enum": dataType = GraphManager.AttributeDataType.ENUM; break;
+                default: dataType = GraphManager.AttributeDataType.STRING; break;
+            }
+            graphManager.addAttributeType(attributeType.getString("name"), dataType, attributeType.getString("text"));
+        }
+
+        return attributeTypes;
+    }
+
+    /**
+     * Loads the vertex archetypes from the json and adds them to all vertex archetypes.
+     * @param json
+     */
+    private void loadVertexArchetypes(JSONObject json) {
+        JSONArray vertexArchetypes = json.getJSONArray("vertexArchetypes");
+        for (int i = 0; i < vertexArchetypes.size(); i++) {
+            JSONObject vertexArchetype = vertexArchetypes.getJSONObject(i);
+
+            graphManager.addVertexArchetype(vertexArchetype.getString("name"), vertexArchetype.getString("text"));
+        }
+    }
+
+    /**
+     * Loads the edge archetypes from the json and adds them to all edge archetypes.
+     * @param json
+     */
+    private void loadEdgeArchetypes(JSONObject json) {
+        JSONArray edgeArchetypes = json.getJSONArray("edgeArchetypes");
+        for (int i = 0; i < edgeArchetypes.size(); i++) {
+            JSONObject edgeArchetype = edgeArchetypes.getJSONObject(i);
+
+            graphManager.addEdgeArchetype(edgeArchetype.getString("name"), edgeArchetype.getString("text"));
+        }
+    }
+
+    /**
+     * Loads the vertices from the json and adds them to the list of all vertices.
+     * @param attributeTypes - json array with the attribute types
+     * @param json
+     */
+    private void loadVertices(JSONArray attributeTypes, JSONObject json) {
+        JSONArray verticesObject = json.getJSONArray("vertices");
+        for (int i = 0; i < verticesObject.size(); i++) {
+            JSONObject vertexObject = verticesObject.getJSONObject(i);
+            String name = vertexObject.getString("title");
+            String text = vertexObject.getString("text");
+            int archetypeIndex = vertexObject.getInt("archetype");
+            int vertexId = vertexObject.getInt("id");
+            vertexArchetypes.put(vertexId, archetypeIndex);
+
+            JSONObject attributesObject = vertexObject.getJSONObject("attributes");
+            Map<Integer, Attribute> attributes = loadObjectAttributes(attributesObject, attributeTypes);
+
+            graphManager.addVertex(vertexId, name, text, archetypeIndex, attributes);
+        }
+    }
+
+    /**
+     * Loads the edges from the json and adds them to the list of all edges.
+     * @param attributeTypes - List of attributes
+     * @param json
+     */
+    private void loadEdges(JSONArray attributeTypes, JSONObject json) {
+        JSONArray edgesObject = json.getJSONArray("edges");
+        for (int i = 0; i < edgesObject.size(); i++) {
+            JSONObject edgeObject = edgesObject.getJSONObject(i);
+            int edgeId = edgeObject.getInt("id");
+            int from = edgeObject.getInt("from");
+            int to = edgeObject.getInt("to");
+            String text = edgeObject.getString("text");
+            int archetypeIndex = edgeObject.getInt("archetype");
+            int fromArchetypeIndex = vertexArchetypes.get(from);
+            int toArchetypeIndex = vertexArchetypes.get(to);
+
+            JSONObject attributesObject = edgeObject.getJSONObject("attributes");
+            Map<Integer, Attribute> attributes = loadObjectAttributes(attributesObject, attributeTypes);
+
+            EdgeArchetypeInfo archetypeInfo = new EdgeArchetypeInfo(fromArchetypeIndex, archetypeIndex, toArchetypeIndex);
+            graphManager.addEdge(edgeId, from, to, text, archetypeInfo, attributes);
+        }
+    }
+
+    /**
+     * Loads all the attributes for the json object.
+     * @param attributesObject - json object for which to get the attributes
+     * @param attributeTypes - All types of attributes
+     * @return Map of attributes for the json object
+     */
+    private Map<Integer, Attribute> loadObjectAttributes(JSONObject attributesObject, JSONArray attributeTypes) {
+        Map<Integer, Attribute> attributes = new HashMap<>();
+        for (Object attributeKey : attributesObject.keySet()) {
+            Object attrValue = loadAttributeFromObject((String)attributeKey, attributeTypes, attributesObject);
+
+            int attributeTypeIndex = Integer.parseInt((String)attributeKey);
+            attributes.put(attributeTypeIndex, new Attribute(attributeTypeIndex, attrValue));
+        }
+
+        return attributes;
+    }
+
+    /**
+     * Loads single attribute from the json object
+     * @param attributeIdString - Attribute id as key
+     * @param attributeTypes - All the attributes types
+     * @param attributesObject - Object containing all the attributes for the current object
+     * @return Value of the attribute
+     */
+    private Object loadAttributeFromObject(String attributeIdString, JSONArray attributeTypes, JSONObject attributesObject) {
+        int attributeId = Integer.parseInt(attributeIdString);
+        String attrType = attributeTypes.getJSONObject(attributeId).getString("dataType");
+        Object attrValue;
+        switch (attrType) {
+            case "number":
+                String val = attributesObject.getString(attributeIdString);
+                attrValue = new BigDecimal(val);
+                break;
+            case "date":
+                String dateStr = attributesObject.getString(attributeIdString);
+                SimpleDateFormat format = new SimpleDateFormat(GraphJSONDataLoader.DATETIME_FORMAT);
+                attrValue = format.parse(dateStr, new ParsePosition(0));
+                break;
+            case "enum":
+                List<String> enumValues = new ArrayList<>();
+                JSONArray enumValuesArray = attributesObject.optJSONArray(attributeIdString);
+                if (enumValuesArray == null) {
+                    enumValues.add(attributesObject.getString(attributeIdString)); // Only one value present
+                } else {
+                    for (int j = 0; j < enumValuesArray.size(); j++) {
+                        enumValues.add(enumValuesArray.getString(j));
+                    }
+                }
+
+                graphManager.addUniquePossibleAttributeValues(attributeId, enumValues);
+                attrValue = graphManager.getEnumPositionsForAttrIndex(attributeId, enumValues);
+
+                break;
+            default:
+                attrValue = attributesObject.getString(attributeIdString);
+                break;
+        }
+
+        return attrValue;
+    }
+}
